require "sprites"

math.randomseed( os.time() )
hero = {}
hero.maxhealth = 5
hero.health = hero.maxhealth-3
hero.x = 0
hero.y = 50
hero.width = 35
hero.height = 100
hero.attackRange = 60
hero.timeSinceBeingInvincible = love.timer.getMicroTime()
hero.timeBeingInvincible = 1

level = {}
level.maxX = 20000
level.maxY = 2000
level.minX = 0
level.minY = 0
level.width  = level.maxX - level.minX
level.height = level.maxY - level.minY
level.bgmusic = love.audio.newSource( "theme.ogg", "stream" )
level.bgmusic:setLooping(true)
love.audio.play(level.bgmusic)

sounds = {}
sounds.sword = {}
sounds.sword[1] = love.audio.newSource( "sword1.ogg", "static" )
sounds.sword[2] = love.audio.newSource( "sword2.ogg", "static" )
sounds.sword[3] = love.audio.newSource( "sword3.ogg", "static" )
sounds.monsterroar = love.audio.newSource( "monsterroar.ogg", "static" )

level.objects = {}

local index = 1
for y = 0, (level.maxY - level.minY)/100 do
    for x = 0, (level.maxX - level.minX)/100 do
        level.objects[index] = {}
        level.objects[index].spriteIndex = math.random(1,#sprites)
        level.objects[index].sprite = sprites[level.objects[index].spriteIndex]
        level.objects[index].x = math.random(1,level.width) + level.minX  -- x
        level.objects[index].y = math.random(1,level.height) + level.minY -- y
        level.objects[index].lowerY = level.objects[index].y+level.objects[index].sprite:getHeight()
        
        index = index+1
        
    end
end

--level.objects = mergesort(level.objects, "lowerY") --sort by values of index "lowerY", means y-coordinate
table.sort(level.objects, function(a,b) return a.lowerY < b.lowerY end)


level.ais = {}
for i = 1,20 do
    local curMonster = {}
    curMonster.x = math.random(1,level.width) + level.minX  -- x
    curMonster.y = math.random(1,level.height) + level.minY -- y
    curMonster.sprite = sprites.monster
    curMonster.maxhealth = 10
    curMonster.health = curMonster.maxhealth
    curMonster.speed = math.random(90,100)
    curMonster.lowerY = curMonster.y+sprites.monster:getHeight()
    table.insert(level.ais, curMonster)
end